/* $Header: print_pex.c,v 2.1 91/07/11 12:38:02 sinyaw Exp $ */
#ifndef lint
static char sccsid[] = "@(#)print_pex.c 1.5 90/04/05 Copyright SMI/MIT";
#endif

/***********************************************************
Copyright 1989 by Sun Microsystems, Inc. and the X Consortium.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Sun Microsystems,
the X Consortium, and MIT not be used in advertising or publicity 
pertaining to distribution of the software without specific, written 
prior permission.  

SUN MICROSYSTEMS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, 
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT 
SHALL SUN MICROSYSTEMS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL 
DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#include <stdio.h>
#include <X11/X.h>
#include "Xpexlib.h"
#include "pexscope.h"

#define PEX_CARD8       0
#define PEX_CARD16      1
#define PEX_CARD32      2
#define PEX_ENUM        3
#define PEX_FP_FORMAT   4
#define PEX_STRING      5
#define PEX_DRAWABLE	6

#define PrintUval(_STR,_UVAL) \
(void) fprintf( stderr, "_STR: %u\n",_UVAL)

#define PrintVal(_STR,_VAL) \
(void) fprintf( stderr, "_STR: %d\n",_VAL)

#define PrintFval(_STR,_VAL) \
(void) fprintf( stderr, "_STR: %g\n",_VAL)

#define PrintBitmask(_STR,_VALMASK) \
(void) fprintf( stderr, "_STR: 0x%x\n",_VALMASK)

#define PrintString(_STR,_DATA) \
(void) fprintf( stderr, "_STR: %s\n",_DATA)

Nothing( buf)
	register unsigned char *buf;
{
}

GetExtensionInfo( buf)
	register unsigned char *buf;
{
    pexGetExtensionInfoReq *p = (pexGetExtensionInfoReq *) buf;

    PEX_DECODE_REQUEST(GetExtensionInfo,buf);

	pexpr_card("clientProtocolMajor",p->clientProtocolMajor);
	pexpr_card("clientProtocolMinor",p->clientProtocolMinor);
}

GetExtensionInfoReply( buf)
	register unsigned char *buf;
{
    pexGetExtensionInfoReply *p = (pexGetExtensionInfoReply *) buf;

    PEX_DECODE_REPLY(GetExtensionInfo,buf);

	pexpr_card("majorVersion",p->majorVersion);
	pexpr_card("minorVersion",p->minorVersion);
	pexpr_card("release",p->release);
	pexpr_card("lengthName",p->lengthName);
	pexpr_card("subsetInfo",p->subsetInfo);
}

GetEnumeratedTypeInfo( buf)
	register unsigned char *buf;
{
    pexGetEnumeratedTypeInfoReq *p = 
		(pexGetEnumeratedTypeInfoReq *) buf;

	PEX_DECODE_REQUEST(GetEnumeratedTypeInfo,buf);

	pexpr_card("drawable",p->drawable);
	pexpr_card("itemMask",p->itemMask);
	pexpr_card("numEnums",p->numEnums);
}

GetEnumeratedTypeInfoReply( buf)
	register unsigned char *buf;
{
    pexGetEnumeratedTypeInfoReply *p = 
		(pexGetEnumeratedTypeInfoReply *) buf;

    PEX_DECODE_REPLY(GetEnumeratedTypeInfo,buf);

	pexpr_card("numLists",p->numLists);
}

GetImpDepConstants( buf)
	register unsigned char *buf;
{
	pexGetImpDepConstantsReq *p = (pexGetImpDepConstantsReq *) buf;

	PEX_DECODE_REQUEST(GetImpDepConstants,buf);

	pexpr_card("drawable",p->drawable);
	PrintVal(fpFormat,p->fpFormat);
	pexpr_card("numNames",p->numNames);
}

GetImpDepConstantsReply( buf)
	register unsigned char *buf;
{
	pexGetImpDepConstantsReply *rep = 
		(pexGetImpDepConstantsReply *) buf;

	PEX_DECODE_REPLY(GetImpDepConstants,buf);
}

CreateLookupTable( buf)
	register unsigned char *buf;
{
    pexCreateLookupTableReq *p = (pexCreateLookupTableReq *) buf;
    PEX_DECODE_REQUEST(CreateLookupTable,buf);
	PrintUval(drawableExample,p->drawableExample);
	PrintUval(lut,p->lut);
/*	PrintUval(tableType,p->tableType);  */
	pexpr_table_type(p->tableType);
}

CopyLookupTable(buf)
	register unsigned char *buf;
{
	pexCopyLookupTableReq *p = (pexCopyLookupTableReq *) buf;
    PEX_DECODE_REQUEST(CopyLookupTable,buf);
	PrintUval(src,p->src);
	PrintUval(dst,p->dst);
}

FreeLookupTable( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreeLookupTable,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetTableInfo( buf)
	register unsigned char *buf;
{
	pexGetTableInfoReq *p = (pexGetTableInfoReq *) buf;
    PEX_DECODE_REQUEST(GetTableInfo,buf);
	PrintUval(drawableExample,p->drawableExample);
	/* PrintUval(tableType,p->tableType); */
	pexpr_table_type(p->tableType);
}

GetTableInfoReply( buf)
	register unsigned char *buf;
{
	pexGetTableInfoReply *rep = (pexGetTableInfoReply *) buf;
    PEX_DECODE_REPLY(GetTableInfo,buf);
	PrintUval(definableEntries,rep->definableEntries);
	PrintUval(numPredefined,rep->numPredefined);
	PrintUval(predefinedMin,rep->predefinedMin);
	PrintUval(predefinedMax,rep->predefinedMax);
}

GetPredefinedEntries( buf)
	register unsigned char *buf;
{
	pexGetPredefinedEntriesReq *p= 
		(pexGetPredefinedEntriesReq *) buf;
    PEX_DECODE_REQUEST(GetPredefinedEntries,buf);

	PrintVal(fpFormat,p->fpFormat);
	PrintUval(drawableExample,p->drawableExample);
	/* PrintUval(tableType,p->tableType); */
	pexpr_table_type(p->tableType);
	PrintUval(start,p->start);
	PrintUval(count,p->count);
}

GetPredefinedEntriesReply(buf)
register unsigned char *buf;
{
	pexGetPredefinedEntriesReply *p = 
		(pexGetPredefinedEntriesReply *) buf;
    PEX_DECODE_REPLY(GetPredefinedEntries,buf);

	PrintUval(numEntries,p->numEntries); 
}

GetDefinedIndices( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(GetDefinedIndices,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetDefinedIndicesReply(buf)
	register unsigned char *buf;
{
	pexGetDefinedIndicesReply *p = (pexGetDefinedIndicesReply *) buf;
    PEX_DECODE_REPLY(GetDefinedIndices,buf);
	PrintUval(numIndices,p->numIndices);
}

GetTableEntry(buf)
	register unsigned char *buf;
{
	pexGetTableEntryReq *p = (pexGetTableEntryReq *) buf;
    PEX_DECODE_REQUEST(GetTableEntry,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(valueType,p->valueType);
	PrintUval(lut,p->lut);
	PrintUval(index,p->index);
}

GetTableEntryReply( buf)
	register unsigned char *buf;
{
	pexGetTableEntryReply *p = (pexGetTableEntryReply *) buf;
    PEX_DECODE_REPLY(GetTableEntry,buf);
	PrintUval(status,p->status);
	/* PrintUval(tableType,rep->tableType); */
	pexpr_table_type(p->tableType);
}

GetTableEntries( buf)
    register unsigned char *buf;
{
	pexGetTableEntriesReq *p = (pexGetTableEntriesReq *) buf;
	PEX_DECODE_REQUEST(GetTableEntries,buf);
}

GetTableEntriesReply( buf)
	register unsigned char *buf;
{
	pexGetTableEntriesReply *p = (pexGetTableEntriesReply *) buf;
	PEX_DECODE_REPLY(GetTableEntries,buf);
	/* PrintUval(tableType,p->tableType); */
	pexpr_table_type(p->tableType);
	PrintUval(numEntries,p->numEntries);
}

SetTableEntries( buf)
	register unsigned char *buf;
{
    pexSetTableEntriesReq *p = (pexSetTableEntriesReq *) buf;
    PEX_DECODE_REQUEST(SetTableEntries,buf);

	PrintVal(fpFormat,p->fpFormat);
	PrintUval(lut,p->lut);
	PrintUval(start,p->start);
	PrintUval(count,p->count);
}

DeleteTableEntries( buf)
	register unsigned char *buf;
{
	pexDeleteTableEntriesReq *p = (pexDeleteTableEntriesReq *) buf;
	PEX_DECODE_REQUEST(DeleteTableEntries,buf);

	PrintUval(lut,p->lut);
	PrintUval(start,p->start);
	PrintUval(count,p->count);
}

CreatePipelineContext( buf)
	register unsigned char *buf;
{
	pexCreatePipelineContextReq *p = 
		(pexCreatePipelineContextReq *) buf;
    PEX_DECODE_REQUEST(CreatePipelineContext,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(pc,p->pc);
	PrintBitmask(itemMask[0],p->itemMask[0]);
	PrintBitmask(itemMask[1],p->itemMask[1]);
	PrintBitmask(itemMask[2],p->itemMask[2]);
}

CopyPipelineContext( buf)
	register unsigned char *buf;
{
	pexCopyPipelineContextReq *p = (pexCopyPipelineContextReq *) buf;
    PEX_DECODE_REQUEST(CopyPipelineContext,buf);
	PrintUval(src,p->src);
	PrintUval(dst,p->dst);
	PrintBitmask(itemMask[0],p->itemMask[0]);
	PrintBitmask(itemMask[1],p->itemMask[1]);
	PrintBitmask(itemMask[2],p->itemMask[2]);
}

FreePipelineContext( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreePipelineContext,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetPipelineContext( buf)
	register unsigned char *buf;
{
	pexGetPipelineContextReq *p = (pexGetPipelineContextReq *) buf;
    PEX_DECODE_REQUEST(GetPipelineContext,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(pc,p->pc);
	PrintBitmask(itemMask[0],p->itemMask[0]);
	PrintBitmask(itemMask[1],p->itemMask[1]);
	PrintBitmask(itemMask[2],p->itemMask[2]);
}

GetPipelineContextReply( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REPLY(GetPipelineContext,buf);
}

ChangePipelineContext( buf)
	register unsigned char *buf;
{
	pexChangePipelineContextReq *p = 
		(pexChangePipelineContextReq *) buf;
    PEX_DECODE_REQUEST(ChangePipelineContext,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(pc,p->pc);
	PrintBitmask(itemMask[0],p->itemMask[0]);
	PrintBitmask(itemMask[1],p->itemMask[1]);
	PrintBitmask(itemMask[2],p->itemMask[2]);
}

CreateRenderer( buf)
	register unsigned char *buf;
{
	pexCreateRendererReq *p = (pexCreateRendererReq *) buf;
    PEX_DECODE_REQUEST(CreateRenderer,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(rdr,p->rdr);
	PrintUval(drawable,p->drawable);
	PrintBitmask(itemMask,p->itemMask);
}

FreeRenderer( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreeRenderer,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

ChangeRenderer( buf)
	register unsigned char *buf;
{
	pexChangeRendererReq *p = (pexChangeRendererReq *) buf;
    PEX_DECODE_REQUEST(ChangeRenderer,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(rdr,p->rdr);
	PrintBitmask(itemMask,p->itemMask);
}

GetRendererAttributes( buf)
	register unsigned char *buf;
{
	pexGetRendererAttributesReq *p = 
		(pexGetRendererAttributesReq *) buf;
    PEX_DECODE_REQUEST(GetRendererAttributes,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(rdr,p->rdr);
	PrintBitmask(itemMask,p->itemMask);
}

GetRendererAttributesReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetRendererAttributes,buf);
}

GetRendererDynamics( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(GetRendererDynamics,buf);
	PrintUval(id,((pexResourceReq *) buf)->id);
}

GetRendererDynamicsReply( buf)
	register unsigned char *buf;
{
	pexGetRendererDynamicsReply *p = 
		(pexGetRendererDynamicsReply *) buf;
    PEX_DECODE_REPLY(GetRendererDynamics,buf);
	PrintBitmask(table,p->tables);
	PrintBitmask(namesets,p->namesets);
	PrintBitmask(attributes,p->attributes);
}

BeginRendering( buf)
	register unsigned char *buf;
{
	pexBeginRenderingReq *p = (pexBeginRenderingReq *) buf;
    PEX_DECODE_REQUEST(BeginRendering,buf);
	PrintUval(rdr,p->rdr);
	PrintUval(drawable,p->drawable);
}

EndRendering( buf)
	register unsigned char *buf;
{
	pexEndRenderingReq *p = (pexEndRenderingReq *) buf;
    PEX_DECODE_REQUEST(EndRendering,buf);
	PrintUval(rdr,p->rdr);
	PrintUval(flushFlag,p->flushFlag);
}

BeginStructure( buf)
	register unsigned char *buf;
{
	pexBeginStructureReq *p = (pexBeginStructureReq *) buf;
	PEX_DECODE_REQUEST(BeginStructure,buf);
	PrintUval(rdr,p->rdr);
	PrintUval(sid,p->sid);
}

EndStructure( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(EndStructure,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

RenderOutputCommands( buf)
	register unsigned char *buf;
{
    pexRenderOutputCommandsReq *p = (pexRenderOutputCommandsReq *) buf;
    CARD32 num_cmds = p->numCommands;

    PEX_DECODE_REQUEST(RenderOutputCommands,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(rdr,p->rdr);
	PrintUval(numCommands,p->numCommands);

    buf += sizeof(pexRenderOutputCommandsReq);
    pex_decode_elem(num_cmds, (unsigned char *)(buf));
}

RenderNetwork( buf)
	register unsigned char *buf;
{
	pexRenderNetworkReq *p = (pexRenderNetworkReq *) buf;
    PEX_DECODE_REQUEST(RenderNetwork,buf);
	PrintUval(rdr,p->rdr);
	PrintUval(drawable,p->drawable);
	PrintUval(sid,p->sid);
}

CreateStructure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(CreateStructure,buf);
	PrintUval(id,((pexResourceReq *) buf)->id);
}

CopyStructure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(CopyStructure,buf);
	PrintUval(src,((pexCopyStructureReq *) buf)->src);
	PrintUval(dst,((pexCopyStructureReq *) buf)->dst);
}


DestroyStructures( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(DestroyStructures,buf);
	PrintUval(numStructures,((pexDestroyStructuresReq *)buf)->numStructures);
}

GetStructureInfo( buf)
	register unsigned char *buf;
{
	pexGetStructureInfoReq *p = (pexGetStructureInfoReq *) buf;
	PEX_DECODE_REQUEST(GetStructureInfo,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintBitmask(itemMask,p->itemMask);
	PrintUval(sid,p->sid);
}

GetStructureInfoReply( buf)
	register unsigned char *buf;
{
	pexGetStructureInfoReply *p = (pexGetStructureInfoReply *) buf;
    PEX_DECODE_REPLY(GetStructureInfo,buf);
	pexpr_editing_mode(p->editMode);
	/* PrintUval(editMode,p->editMode); */
	PrintUval(elementPtr,p->elementPtr);
	PrintUval(numElements,p->numElements);
	PrintUval(lengthStructure,p->lengthStructure);
	PrintUval(hasRefs,p->hasRefs);
}

GetElementInfo( buf)
	register unsigned char *buf;
{
	pexGetElementInfoReq *p = (pexGetElementInfoReq *) buf;
    PEX_DECODE_REQUEST(GetElementInfo,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(sid,p->sid);
	pexpr_whence("range.position1.whence",p->range.position1.whence);
	PrintVal(range.position1.offset,p->range.position1.offset);
	pexpr_whence("range.position2.whence",p->range.position2.whence);
	PrintVal(range.position2.offset,p->range.position2.offset);
}

GetElementInfoReply( buf)
	register unsigned char *buf;
{
	pexGetElementInfoReply *p = 
		(pexGetElementInfoReply *) buf;
	PEX_DECODE_REPLY(GetElementInfo,buf);
	PrintUval(numInfo,p->numInfo);
}

GetStructuresInNetwork( buf)
	register unsigned char *buf;
{
	pexGetStructuresInNetworkReq *p = 
		(pexGetStructuresInNetworkReq *) buf;
    PEX_DECODE_REQUEST(GetStructuresInNetwork,buf);
	PrintUval(sid,p->sid);
	PrintUval(which,p->which);
}

GetStructuresInNetworkReply( buf)
	register unsigned char *buf;
{
	pexGetStructuresInNetworkReply *p = 
		(pexGetStructuresInNetworkReply *) buf;
    PEX_DECODE_REPLY(GetStructuresInNetwork,buf);
	PrintUval(numStructures,p->numStructures);
}

GetAncestors( buf)
	register unsigned char *buf;
{
	pexGetAncestorsReq *p = (pexGetAncestorsReq *) buf;
    PEX_DECODE_REQUEST(GetAncestors,buf);
	PrintUval(sid,p->sid);
	PrintUval(pathOrder,p->pathOrder);
	PrintUval(pathDepth,p->pathDepth);
}

GetAncestorsReply( buf)
	register unsigned char *buf;
{
	pexGetAncestorsReply *p = (pexGetAncestorsReply *) buf;
    PEX_DECODE_REPLY(GetAncestors,buf);
	PrintUval(numPaths,p->numPaths);
}

GetDescendants( buf)
	register unsigned char *buf;
{
	pexGetDescendantsReq *p = (pexGetDescendantsReq *) buf;
    PEX_DECODE_REQUEST(GetDescendants,buf);
	PrintUval(sid,p->sid);
	PrintUval(pathOrder,p->pathOrder);
	PrintUval(pathDepth,p->pathDepth);
}

GetDescendantsReply( buf)
	register unsigned char *buf;
{
	pexGetDescendantsReply *p = (pexGetDescendantsReply *) buf;
    PEX_DECODE_REPLY(GetDescendants,buf);
	PrintUval(numPaths,p->numPaths);
}

FetchElements( buf)
	register unsigned char *buf;
{
	pexFetchElementsReq *p = (pexFetchElementsReq *) buf;
	PEX_DECODE_REQUEST(FetchElements,buf);

	PrintVal(fpFormat,p->fpFormat);
	PrintUval(sid,p->sid);
	pexpr_whence("position1.whence",p->range.position1.whence);
	PrintVal(postion1.offset,p->range.position1.offset);
	pexpr_whence("position2.whence",p->range.position2.whence);
	PrintVal(position2.offset,p->range.position2.offset);
}

FetchElementsReply( buf)
	register unsigned char *buf;
{
	pexFetchElementsReply *p = (pexFetchElementsReply *) buf;
    PEX_DECODE_REPLY(FetchElements,buf);
	PrintUval(numElements,p->numElements);
}

SetEditingMode( buf)
	register unsigned char *buf;
{
    pexSetEditingModeReq *p = (pexSetEditingModeReq *) buf;
    PEX_DECODE_REQUEST(SetEditingMode,buf);
	PrintUval(sid,p->sid);
	pexpr_editing_mode(p->mode);
}
	
SetElementPointer( buf)
	register unsigned char *buf;
{
    pexSetElementPointerReq *p = (pexSetElementPointerReq *) buf;
    PEX_DECODE_REQUEST(SetElementPointer,buf);
	PrintUval(sid,p->sid);
	pexpr_whence("position.whence",p->position.whence);
	PrintVal(position.offset,p->position.offset);
}

SetElementPointerAtLabel( buf)
	register unsigned char *buf;
{
    pexSetElementPointerAtLabelReq *p = 
		(pexSetElementPointerAtLabelReq *) buf;
    PEX_DECODE_REQUEST(SetElementPointerAtLabel,buf);
	PrintUval(sid,p->sid);
	PrintUval(label,p->label);
	PrintUval(offset,p->offset);
}

ElementSearch( buf)
	register unsigned char *buf;
{
	pexElementSearchReq *p = (pexElementSearchReq *) buf;
    PEX_DECODE_REQUEST(ElementSearch,buf);
	PrintUval(sid,p->sid);
	pexpr_whence("position.whence",p->position.whence);
	PrintVal(position.offset,p->position.offset);
	PrintUval(direction,p->direction);
	PrintUval(numIncls,p->numIncls);
	PrintUval(numExcls,p->numExcls);
}

ElementSearchReply( buf)
	register unsigned char *buf;
{
	pexElementSearchReply *p = (pexElementSearchReply *) buf;
    PEX_DECODE_REPLY(ElementSearch,buf);
	PrintUval(status,p->status);
	PrintUval(foundOffset,p->foundOffset);
}

StoreElements( buf)
	register unsigned char *buf;
{
    pexStoreElementsReq *p = (pexStoreElementsReq *) buf;
    CARD32 num_cmds = p->numCommands;
    PEX_DECODE_REQUEST(StoreElements,buf);
	PrintUval(sid,p->sid);
	PrintUval(numCommands,p->numCommands);
    buf += sizeof(pexStoreElementsReq);
    pex_decode_elem(num_cmds, (unsigned char *)(buf));
}

DeleteElements( buf)
	register unsigned char *buf;
{
	pexDeleteElementsReq *p = (pexDeleteElementsReq *) buf;
    PEX_DECODE_REQUEST(DeleteElements,buf);
	PrintUval(sid,p->sid);
	pexpr_whence("range.position1.whence",p->range.position1.whence);
	PrintVal(range.position1.offset,p->range.position1.offset);
	pexpr_whence("range.position2.whence",p->range.position2.whence);
	PrintVal(range.position2.offset,p->range.position2.offset);
}

DeleteElementsToLabel( buf)
	register unsigned char *buf;
{
	pexDeleteElementsToLabelReq *p = 
		(pexDeleteElementsToLabelReq *) buf;
    PEX_DECODE_REQUEST(DeleteElementsToLabel,buf);
	PrintUval(sid,p->sid);
	pexpr_whence("position.whence",p->position.whence);
	PrintVal(position.offset,p->position.offset);
	PrintVal(label,p->label);
}

DeleteBetweenLabels( buf)
	register unsigned char *buf;
{
    pexDeleteBetweenLabelsReq *p = 
		(pexDeleteBetweenLabelsReq *) buf;
    PEX_DECODE_REQUEST(DeleteBetweenLabels,buf);
	PrintUval(sid,p->sid);
	PrintVal(label1,p->label1);
	PrintVal(label1,p->label2);
}

CopyElements( buf)
	register unsigned char *buf;
{
	pexCopyElementsReq *p = (pexCopyElementsReq *) buf;
    PEX_DECODE_REQUEST(CopyElements,buf);
	PrintUval(src,p->src);
	pexpr_whence("srcRange.position1.whence", 
		p->srcRange.position1.whence);
	PrintVal(srcRange.position1.offset,p->srcRange.position1.offset);
	PrintVal(srcRange.position2.offset,p->srcRange.position2.offset);
	pexpr_whence("srcRange.position2.whence", 
		p->srcRange.position2.whence);
	PrintUval(dst,p->dst);
	pexpr_whence("dstPosition.whence", 
		p->dstPosition.whence);
	PrintVal(dstPosition.offset,p->dstPosition.offset);
}

ChangeStructureRefs( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(ChangeStructureRefs,buf);
	PrintUval(old,((pexChangeStructureRefsReq *)buf)->old_id);
	PrintUval(new,((pexChangeStructureRefsReq *)buf)->new_id);
}

CreateNameSet( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(CreateNameSet,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

CopyNameSet( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(CopyNameSet,buf);
	PrintUval(src,((pexCopyNameSetReq *)buf)->src);
	PrintUval(dst,((pexCopyNameSetReq *)buf)->dst);
}

FreeNameSet( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreeNameSet,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetNameSet( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(GetNameSet,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetNameSetReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetNameSet,buf);
	PrintUval(numNames,((pexGetNameSetReply *)buf)->numNames);
}

ChangeNameSet( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(ChangeNameSet,buf);
	PrintUval(ns,((pexChangeNameSetReq *)buf)->ns);
	PrintUval(action,((pexChangeNameSetReq *)buf)->action);
}

CreateSearchContext( buf)
	register unsigned char *buf;
{
	pexCreateSearchContextReq *p = (pexCreateSearchContextReq *) buf;
    PEX_DECODE_REQUEST(CreateSearchContext,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(sc,p->sc);
	PrintBitmask(itemMask,p->itemMask);
}

CopySearchContext( buf)
	register unsigned char *buf;
{
	pexCopySearchContextReq *p = (pexCopySearchContextReq *) buf;
    PEX_DECODE_REQUEST(CopySearchContext,buf);

	PrintUval(src,p->src);
	PrintUval(dst,p->dst);
	PrintBitmask(itemMask,p->itemMask);
}

FreeSearchContext( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreeSearchContext,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetSearchContext( buf)
	register unsigned char *buf;
{
	pexGetSearchContextReq *p = (pexGetSearchContextReq *) buf;
    PEX_DECODE_REQUEST(GetSearchContext,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(fpFormat,p->sc);
	PrintBitmask(itemMask,p->itemMask);
}

GetSearchContextReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetSearchContext,buf);
}

ChangeSearchContext( buf)
	register unsigned char *buf;
{
	pexChangeSearchContextReq *p = (pexChangeSearchContextReq *) buf;
    PEX_DECODE_REQUEST(ChangeSearchContext,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(sc,p->sc);
	PrintBitmask(itemMask,p->itemMask);
}

SearchNetwork( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(SearchNetwork,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

SearchNetworkReply( buf)
	register unsigned char *buf;
{
	pexSearchNetworkReply *p = 
		(pexSearchNetworkReply *) buf;
	PEX_DECODE_REPLY(SearchNetwork,buf);
	PrintUval(numItems,p->numItems);
}

CreatePhigsWks( buf)
	register unsigned char *buf;
{
    pexCreatePhigsWksReq *p = (pexCreatePhigsWksReq *)buf;
    PEX_DECODE_REQUEST(CreatePhigsWks,buf);
	PrintUval(wks,p->wks);
	PrintUval(drawable,p->drawable);
	PrintUval(markerBundle,p->markerBundle);
	PrintUval(textBundle,p->textBundle);
	PrintUval(lineBundle,p->lineBundle);
	PrintUval(interiorBundle,p->interiorBundle);
	PrintUval(edgeBundle,p->edgeBundle);
	PrintUval(colourTable,p->colourTable);
	PrintUval(depthCueTable,p->depthCueTable);
	PrintUval(lightTable,p->lightTable);
	PrintUval(colourApproxTable,p->colourApproxTable);
	PrintUval(patternTable,p->patternTable);
	PrintUval(textFontTable,p->textFontTable);
	PrintUval(highlightIncl,p->highlightIncl);
	PrintUval(highlightExcl,p->highlightExcl);
	PrintUval(invisIncl,p->invisIncl);
	PrintUval(invisExcl,p->invisExcl);
	pexpr_buffer_mode(p->bufferMode);
	/* PrintUval(bufferMode,p->bufferMode); */
}

FreePhigsWks( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreePhigsWks,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetWksInfo( buf)
	register unsigned char *buf;
{
	pexGetWksInfoReq *p = (pexGetWksInfoReq *) buf;
    PEX_DECODE_REQUEST(GetWksInfo,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(wks,p->wks);
	PrintBitmask(itemMask[0],p->itemMask[0]);
	PrintBitmask(itemMask[1],p->itemMask[1]);
}

GetWksInfoReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetWksInfo,buf);
}

GetDynamics( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(GetDynamics,buf);
	PrintUval(drawable,((pexGetDynamicsReq *)buf)->drawable);
}

GetDynamicsReply( buf)
	register unsigned char *buf;
{
	pexGetDynamicsReply *p = (pexGetDynamicsReply *) buf;
    PEX_DECODE_REPLY(GetDynamics,buf);
	PrintUval(viewRep,p->viewRep);
	PrintUval(markerBundle,p->markerBundle);
	PrintUval(textBundle,p->textBundle);
	PrintUval(lineBundle,p->lineBundle);
	PrintUval(interiorBundle,p->interiorBundle);
	PrintUval(edgeBundle,p->edgeBundle);
	PrintUval(colourTable,p->colourTable);
	PrintUval(patternTable,p->patternTable);
	PrintUval(wksTransform,p->wksTransform);
	PrintUval(highlightFilter,p->highlightFilter);
	PrintUval(invisibilityFilter,p->invisibilityFilter);
	PrintUval(HlhsrMode,p->HlhsrMode);
	PrintUval(structureModify,p->structureModify);
	PrintUval(postStructure,p->postStructure);
	PrintUval(unpostStructure,p->unpostStructure);
	PrintUval(deleteStructure,p->deleteStructure);
	PrintUval(referenceModify,p->referenceModify);
	PrintUval(bufferModify,p->bufferModify);
}

GetViewRep( buf)
	register unsigned char *buf;
{
	pexGetViewRepReq *p = (pexGetViewRepReq *) buf;
    PEX_DECODE_REQUEST(GetViewRep,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(index,p->index);
	PrintUval(wks,p->wks);
}

GetViewRepReply( buf)
	register unsigned char *buf;
{
	pexGetViewRepReply *p = (pexGetViewRepReply *) buf;
	pexViewRep *vr;
    PEX_DECODE_REPLY(GetViewRep,buf);
	PrintUval(viewUpdate,p->viewUpdate);
	p += sizeof(pexGetViewRepReply);
	vr = (pexViewRep *) p;
	PrintUval(vr->index,vr->index);
}

RedrawAllStructures( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(RedrawAllStructures,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

UpdateWorkstation( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(UpdateWorkstation,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

RedrawClipRegion( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(RedrawClipRegion,buf);
	PrintUval(wks,((pexRedrawClipRegionReq *)buf)->wks);
	PrintUval(numRects,((pexRedrawClipRegionReq *)buf)->numRects);
}

ExecuteDeferredActions( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(ExecuteDeferredActions,buf);
    
	PrintUval(id,((pexResourceReq *)buf)->id);
}

SetViewPriority(buf)
register unsigned char *buf;
{
	PEX_DECODE_REQUEST(SetViewPriority,buf);
	PrintUval(wks,((pexSetViewPriorityReq *)buf)->wks);
	PrintUval(index1,((pexSetViewPriorityReq *)buf)->index1);
	PrintUval(index2,((pexSetViewPriorityReq *)buf)->index2);
	PrintUval(priority,((pexSetViewPriorityReq *)buf)->priority);
}

SetDisplayUpdateMode( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(SetDisplayUpdateMode,buf);
	PrintUval(wks,((pexSetDisplayUpdateModeReq *)buf)->wks);
	PrintUval(mode,((pexSetDisplayUpdateModeReq *)buf)->displayUpdate);
}

MapDCtoWC( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(MapDCtoWC,buf);
	PrintVal(fpFormat,((pexMapDCtoWCReq *)buf)->fpFormat);
	PrintUval(wks,((pexMapDCtoWCReq *)buf)->wks);
	PrintUval(numCoords,((pexMapDCtoWCReq *)buf)->numCoords);
}

MapDCtoWCReply( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REPLY(MapDCtoWC,buf);
	PrintUval(viewIndex,((pexMapDCtoWCReply *)buf)->viewIndex);
	PrintUval(numCoords,((pexMapDCtoWCReply *)buf)->numCoords);
}

MapWCtoDC( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(MapWCtoDC,buf);
	PrintVal(fpFormat,((pexMapWCtoDCReq *)buf)->fpFormat);
	PrintUval(index,((pexMapWCtoDCReq *)buf)->index);
	PrintUval(wks,((pexMapWCtoDCReq *)buf)->wks);
	PrintUval(numCoords,((pexMapWCtoDCReq *)buf)->numCoords);
}

MapWCtoDCReply(buf)
register unsigned char *buf;
{
    PEX_DECODE_REPLY(MapWCtoDC,buf);
	PrintUval(numCoords,((pexMapWCtoDCReply *)buf)->numCoords);
}

#define PrintNpcSubvolume(_NPC) \
(void) fprintf( stderr, \
"( xmin: %g ymin: %g zmin: %g)\n(xmax: %g ymax: %g zmax: %g\n", \
_NPC.minval.x, \
_NPC.minval.y, \
_NPC.minval.z, \
_NPC.maxval.x, \
_NPC.maxval.y, \
_NPC.maxval.z )

#define PrintMatrix(_M) \
{ \
register long i = 4; \
\
while ( i--) { \
(void) fprintf( stderr, \
"(%g, %g, %g, %g)\n", \
_M[0][i], _M[1][i], _M[2][i], _M[3][i]); \
} \
}

#define PrintCR \
(void) fprintf( stderr, "\n");

SetViewRep(buf)
register unsigned char *buf;
{
    long register i;
    pexSetViewRepReq *p = (pexSetViewRepReq *)buf;
    PEX_DECODE_REQUEST(SetViewRep,buf);
	PrintUval(wks,p->wks);
	PrintUval(viewRep.index,p->viewRep.index);
	PrintBitmask(viewRep.view.clipFlags,p->viewRep.view.clipFlags);
	PrintNpcSubvolume(p->viewRep.view.clipLimits);
	PrintMatrix(p->viewRep.view.orientation);
	PrintCR;
	PrintMatrix(p->viewRep.view.mapping);
}

SetWksWindow( buf)
	register unsigned char *buf;
{
	pexSetWksWindowReq *p = (pexSetWksWindowReq *) buf;
	PEX_DECODE_REQUEST(SetWksWindow,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(wks,p->wks);
	PrintNpcSubvolume(p->npcSubvolume);
}

#define PrintDeviceCoord(_STR,_DC) \
(void) fprintf( stderr, "_STR: %d, %d, %g\n", \
_DC.x, _DC.y, _DC.z)

SetWksViewport( buf)
	register unsigned char *buf;
{
	pexSetWksViewportReq *p = (pexSetWksViewportReq *) buf;
	PEX_DECODE_REQUEST(SetWksViewport,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(wks,p->wks);
	PrintDeviceCoord(minval(x,y,z),p->viewport.minval);
	PrintDeviceCoord(maxval(x,y,z),p->viewport.maxval);
	PrintUval(useDrawable,p->viewport.useDrawable);
}

SetHlhsrMode( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(SetHlhsrMode,buf);
	PrintUval(wks,((pexSetHlhsrModeReq *)buf)->wks);
	PrintVal(mode,((pexSetHlhsrModeReq *)buf)->mode);
}

PostStructure( buf)
	register unsigned char *buf;
{
    pexPostStructureReq *p = (pexPostStructureReq *) buf;
    PEX_DECODE_REQUEST(PostStructure,buf);
	PrintUval(wks,p->wks);
	PrintUval(sid,p->sid);
	PrintFval(priority,p->priority);
}

UnpostStructure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(UnpostStructure,buf);
	PrintUval(wks,((pexUnpostStructureReq *)buf)->wks);
	PrintUval(sid,((pexUnpostStructureReq *)buf)->sid);
}

UnpostAllStructures( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(UnpostAllStructures,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetWksPostings(buf)
register unsigned char *buf;
{
    PEX_DECODE_REQUEST(GetWksPostings,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetWksPostingsReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetWksPostings,buf);
}

GetPickDevice( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(GetPickDevice,buf);
	PrintVal(fpFormat,((pexGetPickDeviceReq *)buf)->fpFormat);
	PrintVal(devType,((pexGetPickDeviceReq *)buf)->devType);
	PrintUval(wks,((pexGetPickDeviceReq *)buf)->wks);
	PrintBitmask(itemMask,((pexGetPickDeviceReq *)buf)->itemMask);
}

GetPickDeviceReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetPickDevice,buf);
}

ChangePickDevice( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(ChangePickDevice,buf);
	PrintVal(fpFormat,((pexGetPickDeviceReq *)buf)->fpFormat);
	PrintUval(wks,((pexGetPickDeviceReq *)buf)->wks);
	PrintVal(devType,((pexGetPickDeviceReq *)buf)->devType);
	PrintBitmask(itemMask,((pexGetPickDeviceReq *)buf)->itemMask);
}

CreatePickMeasure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(CreatePickMeasure,buf);
	PrintUval(wks,((pexCreatePickMeasureReq *)buf)->wks);
	PrintUval(pm,((pexCreatePickMeasureReq *)buf)->pm);
	PrintVal(devType,((pexCreatePickMeasureReq *)buf)->devType);
}

FreePickMeasure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(FreePickMeasure,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

GetPickMeasure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(GetPickMeasure,buf);
	PrintUval(pm,((pexGetPickMeasureReq *)buf)->pm);
	PrintBitmask(itemMask,((pexGetPickMeasureReq *)buf)->itemMask);
}

GetPickMeasureReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(GetPickMeasure,buf);
}

UpdatePickMeasure( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(UpdatePickMeasure,buf);
	PrintUval(pm,((pexUpdatePickMeasureReq *)buf)->pm);
	PrintUval(numBytes,((pexUpdatePickMeasureReq *)buf)->numBytes);
}

OpenPexFont( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(OpenFont,buf);
	PrintUval(font,((pexOpenFontReq *)buf)->font);
	PrintUval(numBytes,((pexOpenFontReq *)buf)->numBytes);
}

ClosePexFont( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(CloseFont,buf);
	PrintUval(id,((pexResourceReq *)buf)->id);
}

QueryPexFont( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REQUEST(QueryFont,buf);
	PrintUval(font,((pexQueryFontReq *)buf)->font);
}

QueryPexFontReply( buf)
	register unsigned char *buf;
{
	pexQueryFontReply *p = (pexQueryFontReply *) buf;
    PEX_DECODE_REPLY(QueryFont,buf);
	PrintUval(lengthFontInfo,p->lengthFontInfo);
}

ListPexFonts( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(ListFonts,buf);
	PrintUval(maxNames,((pexListFontsReq *)buf)->maxNames);
	PrintUval(numChars,((pexListFontsReq *)buf)->numChars);
}

ListPexFontsReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(ListFonts,buf);
	PrintUval(numStrings,((pexListFontsReply *)buf)->numStrings);
}

ListPexFontsWithInfo( buf)
	register unsigned char *buf;
{
	PEX_DECODE_REQUEST(ListFontsWithInfo,buf);
	PrintUval(maxNames,((pexListFontsWithInfoReq *)buf)->maxNames);
	PrintUval(numChars,((pexListFontsWithInfoReq *)buf)->numChars);
}

ListPexFontsWithInfoReply( buf)
	register unsigned char *buf;
{
	pexListFontsWithInfoReply *p = 
		(pexListFontsWithInfoReply *) buf;
    PEX_DECODE_REPLY(ListFontsWithInfo,buf);
	PrintUval(numStrings,p->numStrings);
}

QueryPexTextExtents( buf)
	register unsigned char *buf;
{
	pexQueryTextExtentsReq *p = (pexQueryTextExtentsReq *) buf;
    PEX_DECODE_REQUEST(QueryTextExtents,buf);
	PrintVal(fpFormat,p->fpFormat);
	PrintUval(textPath,p->textPath);
	PrintUval(fontGroupIndex,p->fontGroupIndex);
	PrintUval(id,p->id);
	PrintFval(charExpansion,p->charExpansion);
	PrintFval(charSpacing,p->charSpacing);
	PrintFval(charHeight,p->id);
	PrintUval(vertical,p->textAlignment.vertical);
	PrintUval(horizontal,p->textAlignment.horizontal);
	PrintUval(numStrings,p->numStrings);
}

QueryPexTextExtentsReply( buf)
	register unsigned char *buf;
{
    PEX_DECODE_REPLY(QueryTextExtents,buf);
}


/**
 **
 **	PEX Error Printing procedures
 **
 **/

ColorTypeError( buf)
	register unsigned char *buf;
{
    pexColourTypeError *err = (pexColourTypeError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_color_type,err->badColourType);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

RendererStateError( buf)
	register unsigned char *buf;
{
    pexRendererStateError *err = (pexRendererStateError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_renderer_ID,err->badRendererId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

FloatingPointFormatError( buf)
	register unsigned char *buf;
{
    pexFloatingPointFormatError *err = 
		(pexFloatingPointFormatError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_format,err->badFormat);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

LabelError( buf)
	register unsigned char *buf;
{
    extern char *dbpexReqType();

    pexLabelError *err = (pexLabelError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_label,err->badLabel);
	PrintUval(minorOpcode,err->minorOpcode);
	PrintUval(majorOpcode,err->majorOpcode);
}

LookupTableError( buf)
	register unsigned char *buf;
{
    pexLookupTableError *err = (pexLookupTableError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_table_ID,err->badId);
	PrintUval(minorOpcode,err->minorOpcode);
	PrintUval(majorOpcode,err->majorOpcode);
}

NamesetError( buf)
	register unsigned char *buf;
{
    pexNamesetError *err = (pexNamesetError *) buf;
    
	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_nameset_ID,err->badId);
	PrintUval(minorOpcode,err->minorOpcode);
	PrintUval(majorOpcode,err->majorOpcode);
}

PathError( buf)
	register unsigned char *buf;
{
    pexPathError *err = (pexPathError *) buf;
    
	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_path_ID,err->badId);
	PrintUval(minorOpcode,err->minorOpcode);
	PrintUval(majorOpcode,err->majorOpcode);
}

PexFontError( buf)
	register unsigned char *buf;
{
    pexPexFontError *err = (pexPexFontError *) buf;
    
	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_font_ID,err->badId);
	PrintUval(minorOpcode,err->minorOpcode);
	PrintUval(majorOpcode,err->majorOpcode);
}

PhigsWksError( buf)
    register unsigned char *buf;
{
    pexPhigsWksError *err = (pexPhigsWksError *) buf;
    
	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_PHIGS_workstation_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

PickMeasureError( buf)
	register unsigned char *buf;
{
    pexPickMeasureError *err = (pexPickMeasureError *) buf;
    
	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_device_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

PipelineContextError( buf)
	register unsigned char *buf;
{
    pexPipelineContextError *err = (pexPipelineContextError *) buf;
    
	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_pipeline_context_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

RendererError( buf)
	register unsigned char *buf;
{
    pexRendererError *err = (pexRendererError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_renderer_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

SearchContextError( buf)
	register unsigned char *buf;
{
    pexSearchContextError *err = (pexSearchContextError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_search_context_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

StructureError( buf)
	register unsigned char *buf;
{
    pexStructureError *err = (pexStructureError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_structure_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}

OutputCommandError( buf)
	register unsigned char *buf;
{
	pexOutputCmdError *err = (pexOutputCmdError *) buf;

	PrintUval(sequence_number,err->sequenceNumber);
	PrintUval(bad_resource_ID,err->badId);
	PrintUval(minor_opcode,err->minorOpcode);
	PrintUval(major_opcode,err->majorOpcode);
}
